<?php
session_start();
//ini_set('display_errors',1);

require_once ("../../config/Cado.php");

require_once("../producto/cProducto.php");
$oProducto = new cProducto();
require_once("../presentacion/cPresentacion.php");
$oPresentacion = new cPresentacion();
require_once("../producto/cCatalogo.php");
$oCatalogo = new cCatalogo();
require_once("../marca/cMarca.php");
$oMarca = new cMarca();
require_once ("../familia/cFamilia.php");
$oFamilia = new cFamilia();
require_once("../producto/cProductomarca.php");
$oProductomarca = new cProductomarca();

require_once("../producto/cProductomarcacodigo.php");
$oProductomarcacodigo = new cProductomarcacodigo();

require_once("../producto/cProductofamilia.php");
$oProductofamilia = new cProductofamilia();

require_once("../stock/cStock.php");
$oStock = new cStock();

require_once("../kardex/cKardex.php");
$oKardex = new cKardex();

require_once("../unidad/cUnidad.php");
$oUnidad = new cUnidad();
require_once("../categoria/cCategoria.php");
$oCategoria = new cCategoria();

require_once("../empaque/cEmpaque.php");
$oEmpaque = new cEmpaque();

require_once("../formatos/formato.php");
require_once dirname(__FILE__) . '/../../libreriasphp/phpexcel/Classes/PHPExcel.php';
move_uploaded_file($_FILES['file_archivo']['tmp_name'],$_FILES['file_archivo']['name']);
$archivo = $_FILES['file_archivo']['name'];
$inputFileType = PHPExcel_IOFactory::identify($archivo);
$objReader = PHPExcel_IOFactory::createReader($inputFileType);
$objPHPExcel = $objReader->load($archivo);
$sheet = $objPHPExcel->getSheet(0); 
$highestRow = $sheet->getHighestRow(); 
$highestColumn = $sheet->getHighestColumn();

function ultimoID($oClase){
	$dts = $oClase->ultimoInsert();
	$dt = mysqli_fetch_array($dts);
	mysqli_free_result($dts);
	return $dt['id'];
}

for ($row = 2; $row <= $highestRow; $row++){ 

 //echo $row.' </br> ';

		
		$cate = strtoupper($sheet->getCell("A".$row)->getValue());	
		$pronom = strtoupper($sheet->getCell("B".$row)->getValue());
		$emp = strtoupper($sheet->getCell("C".$row)->getValue());	
		$pre = 'GENERAL';	
		$uni_nom = 'UNIDAD';	
		$codbar = '';			
		$mar = $sheet->getCell("D".$row)->getValue();
		$stock = $sheet->getCell("E".$row)->getValue();
		$pre_cos = $sheet->getCell("F".$row)->getValue();
		$pre_ven = strtoupper($sheet->getCell("G".$row)->getValue());
		$pre_venf = strtoupper($sheet->getCell("H".$row)->getValue());
		$fecven = date('d-m-Y');
		
			$pos = strpos($emp, 'X');
			
			if($pos===false){
				$fac = 1;
				//echo 'entro a';
			}else{
				
				list($fra,$x,$numero) = explode(' ',$emp);
					//echo $numero.'-n-';
				if($numero>0){
					$fac = $numero;
					//echo 'entro s1';
				}else{
					//echo 'entro s2';
					$fac = 1;
				}
				
			}
			
			echo '--'.$fac;
		
			$can1 = 0;
			$can1 = $stock;
			$pos1 = strpos($can1, 'F');
			
			if($pos1===false){
			echo 'ingreso';
			$stockactual  = $can1 * $fac;
			
			}else{
				
			
			$cane = 0;
			$canf = 0;
			list($cane,$canf) = explode('F',$can1);
			$can2 = 0;
			if($cane>0){
				$can2 = $cane*$fac;
			}
			
			//echo $cane.'--'.$canf;
			
			$stockactual = $can2 + $canf;
			//echo $stockactual.'--';
			
			}
		
		
		
		if($uni_nom!=""){
		$rs=$oUnidad->comprobar_si_existe($uni_nom);
		$num=mysqli_num_rows($rs);
		if($num>0){
		$dt = mysqli_fetch_array($rs);			
		$uni_id=$dt['tb_unidad_id'];
		}else{
		$oUnidad->insertar($uni_abr, $uni_nom, '1','1');
		$dts=$oUnidad->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$uni_id=$dt['id'];
		mysqli_free_result($dts);
		}
		}

		$rs=$oCategoria->comprobar_si_existe($cate);
		$num=mysqli_num_rows($rs);
		if($num>0){
		$dt = mysqli_fetch_array($rs);			
		$cat_id=$dt['tb_categoria_id'];
		}else{
		$_POST['txt_color'] = '#010101';
		$oCategoria->insertar($cate, 0 ,$_POST['txt_color']  ,'1');
		$dts=$oCategoria->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$cat_id=$dt['id'];
		mysqli_free_result($dts);
		}

		$rs=$oEmpaque->comprobar_si_existe($emp);
		$num=mysqli_num_rows($rs);
		if($num>0){
		$dt = mysqli_fetch_array($rs);			
		$emp_id=$dt['tb_empaque_id'];
		}else{
		$oEmpaque->insertar($emp,$fac);
		$dts=$oEmpaque->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$emp_id=$dt['id'];
		mysqli_free_result($dts);
		}
/* 
		$rs=$oPresentacion->comprobar_si_existe($pre);
		$num=mysqli_num_rows($rs);
		if($num>0){
		$dt = mysqli_fetch_array($rs);			
		$pre_id=$dt['tb_empaque_id'];
		}else{
		$oPresentacion->insertar($pre);
		$dts=$oPresentacion->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$pre_id=$dt['id'];
		mysqli_free_result($dts);
		} */

		$pre_id = 1;

		if($pronom!=""){
		
		/* $rspro = $oProducto->buscar_por_nombre($pronom);
		$rowspro = mysqli_num_rows($rspro);

		if($rowspro>0){
			
			$dtpro = mysqli_fetch_array($rspro);
			$cat_id = $dtpro['tb_catalogo_id'];
			
		}else{} */
			
		$oProducto->insertar(
		limpia_espacios($pronom),
		limpia_espacios(''),
		'1',
		$cat_id,
		'',
		'',
		$emp_id,
		$pre_id
		);

		$pro_id = ultimoID($oProducto);

		$oCatalogo->insertar(	
		'1', //$_POST['txt_pro_fac_alter'],
		'1',//(isset($_POST['chk_pro_vercom'])?'1':'0'),
		'1',//(isset($_POST['chk_pro_verven'])?'1':'0'),
		'5',
		$uni_id,
		'1',
		$pro_id
		);

		$cat_id = ultimoID($oCatalogo);
		


	$dtsm = $oMarca->comprobar_si_existe($mar);
	$rowsmar = mysqli_num_rows($dtsm);
	if($rowsmar>0){
		$dtm = mysqli_fetch_array($dtsm);
		$mar_id = $dtm['tb_marca_id'];	
	}else{
		$oMarca->insertar($mar);	
		$mar_id = ultimoID($oMarca);	
	}

	$codbar = $pro_id.$cat_id.$mar_id;
	$oProductomarca->insertar(
				$cat_id,
				$mar_id,
				$codbar,
				moneda_mysql($pre_cos),
				moneda_mysql($pre_ven),
				moneda_mysql($pre_venf),
				fecha_mysql($fecven)
		);

	$promar_id = ultimoID($oProductomarca);		


/* 	
	if($codmar1!=""){

			$oProductomarcacodigo->insertar(

				$promar_id,

				'2',

				$codmar1

			);

		}

		

		if($codmar2!=""){

			$oProductomarcacodigo->insertar(

				$promar_id,

				'2',

				$codmar2

			);

		}

	

	 */

	 
	 
	 
	 
		//registro de kardex

		$kar_des='INVENTARIO INICIAL';
		$mod_id = 1;
		$idm=$cat_id;//id de la op(modulo compras, ventas, etc)

		//insertamos kardex

		$oKardex->insertar(			
			fecha_mysql(date('d-m-Y')),
			$kar_des,
			$mod_id,
			$idm,
			$_SESSION['usuario_id'],
			$_SESSION['empresa_id'],
			'0'
		);

		//ultimo kardex

		$dts=$oKardex->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
			$kar_id=$dt['id'];
		mysqli_free_result($dts);

		$kar_tipo=1;//1 entrada 2 salida
		$oKardex->insertar_detalle(
			$cat_id,
			$mar_id,
			$kar_tipo,
			$stockactual,
			moneda_mysql($precos),
			moneda_mysql(''),
			$kar_id,
			'1'
		);	
			

		$oStock->insertar('1',$cat_id,$mar_id,$stockactual);

		}


} 



unlink($archivo);



	/* $data['mar_msj']='Archivo procesado correctamente.';			

	echo json_encode($data); */			

?>